/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.equivalencia;

import com.rjconsultores.ventaboletos.entidad.ComisionistaExterno;
import com.rjconsultores.ventaboletos.entidad.MotivoCancelacion;
import com.rjconsultores.ventaboletos.entidad.MotivocancelacionEquivalencia;
import com.rjconsultores.ventaboletos.service.ComisionistaExternoService;
import com.rjconsultores.ventaboletos.service.MotivoCancelacionService;
import com.rjconsultores.ventaboletos.service.MotivocancelacionEquivalenciaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("editarMotivoCancelacionEquivalenciaController")
@Scope("prototype")
public class EditarMotivoCancelacionEquivalenciaController extends MyGenericForwardComposer {

    @Autowired
    private MotivocancelacionEquivalenciaService motivoCancelacionEquivalenciaService;
    @Autowired
    private ComisionistaExternoService comisionistaExternoService;
    @Autowired
    private MotivoCancelacionService motivoCancelacionService;
    private MotivocancelacionEquivalencia motivoCancelacionEquivalencia;
    private MyListbox motivoCancelacionEquivalenciaList;
    private static Logger log = Logger.getLogger(EditarMotivoCancelacionEquivalenciaController.class);
    private List<ComisionistaExterno> lsComisionistaExterno;
    private List<MotivoCancelacion> lsMotivoCancelacion;
    private Combobox cmbMotivoCancelacion;
    private Combobox cmbComissionestaExterno;
    private Textbox txtEquivalencia;
    private Button btnApagar;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Combobox getCmbComissionestaExterno() {
        return cmbComissionestaExterno;
    }

    public void setCmbComissionestaExterno(Combobox cmbComissionestaExterno) {
        this.cmbComissionestaExterno = cmbComissionestaExterno;
    }

    public Combobox getCmbMotivoCancelacion() {
        return cmbMotivoCancelacion;
    }

    public void setCmbMotivoCancelacion(Combobox cmbMotivoCancelacion) {
        this.cmbMotivoCancelacion = cmbMotivoCancelacion;
    }

    public List<ComisionistaExterno> getLsComisionistaExterno() {
        return lsComisionistaExterno;
    }

    public void setLsComisionistaExterno(List<ComisionistaExterno> lsComisionistaExterno) {
        this.lsComisionistaExterno = lsComisionistaExterno;
    }

    public List<MotivoCancelacion> getLsMotivoCancelacion() {
        return lsMotivoCancelacion;
    }

    public void setLsMotivoCancelacion(List<MotivoCancelacion> lsMotivoCancelacion) {
        this.lsMotivoCancelacion = lsMotivoCancelacion;
    }

    public MotivocancelacionEquivalencia getMotivoCancelacionEquivalencia() {
        return motivoCancelacionEquivalencia;
    }

    public void setMotivoCancelacionEquivalencia(MotivocancelacionEquivalencia motivoCancelacionEquivalencia) {
        this.motivoCancelacionEquivalencia = motivoCancelacionEquivalencia;
    }

    public Textbox getTxtEquivalencia() {
        return txtEquivalencia;
    }

    public void setTxtEquivalencia(Textbox txtEquivalencia) {
        this.txtEquivalencia = txtEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsComisionistaExterno = comisionistaExternoService.obtenerTodos();
        lsMotivoCancelacion = motivoCancelacionService.obtenerTodos();


        super.doAfterCompose(comp);

        motivoCancelacionEquivalencia = (MotivocancelacionEquivalencia) Executions.getCurrent().getArg().get("motivoCancelacionEquivalencia");
        motivoCancelacionEquivalenciaList = (MyListbox) Executions.getCurrent().getArg().get("motivoCancelacionEquivalenciaList");

        if (motivoCancelacionEquivalencia.getMotivoequivalenciaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            cmbComissionestaExterno.setDisabled(true);
            cmbMotivoCancelacion.setDisabled(true);
        }

        cmbMotivoCancelacion.setFocus(true);
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        cmbComissionestaExterno.getSelectedItem();
        cmbMotivoCancelacion.getSelectedItem();
        txtEquivalencia.getText();

        try {
            ComisionistaExterno comisionistaExterno = motivoCancelacionEquivalencia.getComisionistaExterno();
            MotivoCancelacion motivoCancelacion = motivoCancelacionEquivalencia.getMotivoCancelacion();

            List<MotivocancelacionEquivalencia> lsMotivoCancelacionEquivalente =
                    motivoCancelacionEquivalenciaService.buscar(comisionistaExterno,
                    motivoCancelacion);

            boolean podeSalvar = false;
            if (lsMotivoCancelacionEquivalente.isEmpty()) {
                podeSalvar = true;
            } else {
                if (motivoCancelacionEquivalencia.getMotivoequivalenciaId() != null) {
                    for (MotivocancelacionEquivalencia p : lsMotivoCancelacionEquivalente) {
                        if (p.getMotivoequivalenciaId().equals(motivoCancelacionEquivalencia.getMotivoequivalenciaId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }


            List<MotivocancelacionEquivalencia> lsEquivalente =
                    motivoCancelacionEquivalenciaService.buscarEquivalencia(motivoCancelacionEquivalencia);

            boolean podeSalvarEquivalencia = false;
            if (lsEquivalente.isEmpty()) {
                podeSalvarEquivalencia = true;
            } else {
                if (motivoCancelacionEquivalencia.getMotivoequivalenciaId() != null) {
                    for (MotivocancelacionEquivalencia p : lsEquivalente) {
                        if (p.getMotivoequivalenciaId().equals(motivoCancelacionEquivalencia.getMotivoequivalenciaId())) {
                            podeSalvarEquivalencia = true;
                        }
                    }
                }
            }

            if (!podeSalvarEquivalencia) {
                Messagebox.show(
                        Labels.getLabel("MSG.Equivalencia.Existe"),
                        Labels.getLabel("editarMotivoCancelacionEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
                return;
            }
            if (podeSalvar) {
                if (motivoCancelacionEquivalencia.getMotivoequivalenciaId() == null) {
                    motivoCancelacionEquivalenciaService.suscribir(motivoCancelacionEquivalencia);
                    motivoCancelacionEquivalenciaList.addItem(motivoCancelacionEquivalencia);

                } else {
                    motivoCancelacionEquivalenciaService.actualizacion(motivoCancelacionEquivalencia);
                    motivoCancelacionEquivalenciaList.updateItem(motivoCancelacionEquivalencia);
                }
                Messagebox.show(
                        Labels.getLabel("editarMotivoCancelacionEquivalenciaController.MSG.suscribirOK"),
                        Labels.getLabel("editarMotivoCancelacionEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
                closeWindow();
            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarMotivoCancelacionEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarMotivoCancelacionEquivalenciaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);

        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarMotivoCancelacionEquivalenciaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarMotivoCancelacionEquivalenciaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                motivoCancelacionEquivalenciaService.borrar(motivoCancelacionEquivalencia);

                Messagebox.show(
                        Labels.getLabel("editarMotivoCancelacionEquivalenciaController.MSG.borrarOK"),
                        Labels.getLabel("editarMotivoCancelacionEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                motivoCancelacionEquivalenciaList.removeItem(motivoCancelacionEquivalencia);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
